void ProcessDialogEvent()
{
	ref NPChar, PChar, d;
	PChar = GetMainCharacter();
	aref Link, Diag;
	string NPC_Meeting;
	
	DeleteAttribute(&Dialog,"Links");

	makeref(NPChar,CharacterRef);
	makearef(Link, Dialog.Links);
	makeref(d, Dialog);
	makearef(Diag, NPChar.Dialog);
	
	string iDay, iMonth, cargoid, questbookname;
	iDay = environment.date.day;
	iMonth = environment.date.month;
	string lastspeak_date = iday + " " + iMonth;
	ref ctown = GetCurrentTown();
	
	switch(Dialog.CurrentNode)
	{
		case "First time":
			if(CheckAttribute(pchar,"quest.mysterious_plants.declined"))
			{
				Link.l0 = DLG_TEXT[28];
				Link.l0.go = "agree_donate";
			}
			else
			{
				if(sti(GetAttribute(PChar,"quest.mysterious_plants.donate")) < 1000)
				{
					Link.l0 = DLG_TEXT[0];
					Link.l0.go = "Trust Check";
				}
				else
				{
					if(!CheckAttribute(PChar,"quest.mysterious_plants.heard_job"))
					{
						Link.l0 = DLG_TEXT[29];
						Link.l0.go = "Talk Business";
					}
				}
			}
			if(CheckAttribute(PChar,"quest.mysterious_plants.crewmember_killed") && GetAttribute(PChar,"quest.mysterious_plants.heard_job") == "explain")
			{
				Link.l0 = DLG_TEXT[55];
				Link.l0.go = "Meet In Tavern";
			}
			if(CheckAttribute(PChar,"quest.found_vegetal"))
			{
				Link.l1 = DLG_TEXT[64];
				Link.l1.go = "Explain Vegetal";
			}
		break;
		
		case "Explain Vegetal":
			AddDialogExitQuest("Finish Indian Treasure Quest");
			d.Text = DLG_TEXT[65];
			Link.l1 = DLG_TEXT[66];
			Link.l1.go = "exit";
		break;
		
		// ====================== PART 1
		
		case "Trust Check":
			d.Text = DLG_TEXT[1];
			Link.l1 = DLG_TEXT[2];
			Link.l1.go = "Convince"; 
		break;
		
		case "Convince":
			if(CheckAttribute(PChar,"quest.mysterious_plants"))
			{
				SetQuestHeader("plants");
				AddQuestRecord("plants", 1);
			}
			AddQuestRecord("plants", 2);
			d.Text = DLG_TEXT[3];
			Link.l1 = DLG_TEXT[4];
			Link.l1.go = "agree_donate";
			Link.l2 = DLG_TEXT[5];
			Link.l2.go = "decline_donate"; 			
		break;
		
		case "agree_donate":
			d.Text = DLG_TEXT[6];
			Link.l1 = DLG_TEXT[7];
			Link.l1.go = "exit";
			AddDialogExitQuest("Accept Donate Apothecary");			
		break;
		
		case "decline_donate":
			d.Text = DLG_TEXT[8];
			Link.l1 = DLG_TEXT[9];
			Link.l1.go = "exit";
			AddDialogExitQuest("Decline Donate Apothecary"); 			
		break;
		
		case "Killed Mob":
			d.Text = DLG_TEXT[22];
			Link.l1 = DLG_TEXT[23];
			Link.l1.go = "Killed Mob 2";
		break;
		
		case "Killed Mob 2":
			d.Text = DLG_TEXT[24];
			Link.l1 = DLG_TEXT[25];
			Link.l1.go = "Killed Mob 3";
		break;
		
		case "Killed Mob 3":
			AddDialogExitQuest("Officiant helps steven"); 
			d.Text = DLG_TEXT[26];
			Link.l1 = DLG_TEXT[27];
			Link.l1.go = "exit";
		break;
		
		//===================== PART 2
		case "Talk Business":
			AddDialogExitQuest("Apothecary Talk Business");
			d.Text = DLG_TEXT[30];
			Link.l1 = DLG_TEXT[31];
			Link.l1.go = "Talk Business 2";
		break;
		
		case "Talk Business 2":
			d.Text = DLG_TEXT[32];
			Link.l1 = DLG_TEXT[33];
			Link.l1.go = "Talk Business 3";
		break;
		
		case "Talk Business 3":
			d.Text = DLG_TEXT[34];
			Link.l1 = DLG_TEXT[35];
			Link.l1.go = "Talk Business 4";
		break;
		
		case "Talk Business 4":
			d.Text = DLG_TEXT[36];
			Link.l1 = DLG_TEXT[37];
			Link.l1.go = "Talk Business Accept";
			Link.l2 = DLG_TEXT[38];
			Link.l2.go = "Talk Business Decline";
		break;
		
		case "Talk Business Decline":
			d.Text = DLG_TEXT[39];
			Link.l1 = DLG_TEXT[40];
			Link.l1.go = "exit decline business";
			Link.l2 = DLG_TEXT[41];
			Link.l2.go = "Talk Business Reconsider";
		break;
		
		case "Talk Business Reconsider":
			d.Text = DLG_TEXT[42];
			Link.l1 = DLG_TEXT[37];
			Link.l1.go = "Talk Business Accept";
			Link.l2 = DLG_TEXT[38];
			Link.l2.go = "exit decline business";
		break;
		
		case "exit decline business":
			Diag.CurrentNode = Diag.TempNode;
			AddDialogExitQuest("Apothecary Decline Business");
			DialogExit();
		break;
		
		case "Talk Business Accept":
			Diag.CurrentNode = Diag.TempNode;
			AddDialogExitQuest("Talk Business Accept");
			DialogExit();
		break;
		
		case "Discuss Guarded":
			d.Text = DLG_TEXT[45];
			Link.l1 = DLG_TEXT[46];
			Link.l1.go = "Discuss Guarded 2";
		break;
		
		case "Discuss Guarded 2":
			AddDialogExitQuest("Prepare Apothecary Voyage");
			d.Text = DLG_TEXT[47];
			Link.l1 = DLG_TEXT[48];
			Link.l1.go = "exit";
		break;
		
		case "Meet In Tavern":
			AddDialogExitQuest("Apothecary Meet In Tavern");
			d.Text = DLG_TEXT[56];
			Link.l1 = DLG_TEXT[57];
			Link.l1.go = "exit";
		break;
		
		//===================== PART FROM MOB LEADER
		case "Mob Leader":
			d.Text = DLG_TEXT[10];
			Link.l1 = DLG_TEXT[11];
			Link.l1.go = "Choose Mob";
		break;
		
		case "Choose Mob":
			d.Text = DLG_TEXT[12];
			Link.l1 = DLG_TEXT[13];
			Link.l1.go = "Choose BOOM";
			if(sti(PChar.money)>=1000)
			{
				Link.l2 = DLG_TEXT[14];
				Link.l2.go = "Choose Money";
			}
			Link.l3 = DLG_TEXT[15];
			Link.l3.go = "Choose Fight";
		break;
		
		case "Choose BOOM":
			d.Text = DLG_TEXT[16];
			Link.l1 = DLG_TEXT[17];
			Link.l1.go = "exit2";
			AddDialogExitQuest("Apothecary BOOM"); 
		break;
		
		case "Choose Money":
			AddMoneyToCharacter(pchar, -1000);
			d.Text = DLG_TEXT[18];
			Link.l1 = DLG_TEXT[19];
			Link.l1.go = "exit2";
			AddDialogExitQuest("Apothecary Pay"); 
		break;
		
		case "Choose Fight":
			AddMoneyToCharacter(pchar, -1000);
			d.Text = DLG_TEXT[20];
			Link.l1 = DLG_TEXT[21];
			Link.l1.go = "exit2";
			AddDialogExitQuest("Apothecary Fight Mob"); 
		break;
		
		case "exit2":
			Diag.CurrentNode = Diag.TempNode;
			DialogExit();
		break;
		
		//=================== Crew Member Part
		case "Crew Spotted Natives":
			d.Text = DLG_TEXT[43];
			Link.l1 = DLG_TEXT[44];
			Link.l1.go = "exit guarded";
		break;
		
		case "exit guarded":
			AddDialogExitQuest("Apothecary Discuss Guards"); 
			Diag.CurrentNode = Diag.TempNode;
			DialogExit();
		break;
		
		case "Saved from Natives":
			AddDialogExitQuest("Apothecary Crewmember goes to ship");
			d.Text = DLG_TEXT[53];
			Link.l1 = DLG_TEXT[54];
			Link.l1.go = "exit2";
		break;
		
		//=================== Officiant Part
		case "Hit by Blast":
			d.Text = DLG_TEXT[49];
			Link.l1 = DLG_TEXT[50];
			Link.l1.go = "Hit by Blast 2";
		break;
		
		case "Hit by Blast 2":
			AddDialogExitQuest("ResurrectionEvent_OfficiantLeaves");
			d.Text = DLG_TEXT[51];
			Link.l1 = DLG_TEXT[52];
			Link.l1.go = "exit2";
		break;
		
		case "Help Steven Leave":
			d.Text = DLG_TEXT[60];
			Link.l1 = DLG_TEXT[61];
			Link.l1.go = "Help Steven Leave 2";
		break;
		
		case "Help Steven Leave 2":
			AddDialogExitQuest("Steven Leaves");
			d.Text = DLG_TEXT[62];
			Link.l1 = DLG_TEXT[63];
			Link.l1.go = "exit2";
		break;
		
		//================== Captain Part
		case "Talk about plan":
			AddDialogExitQuest("Apothecary Meet At Lighthouse");
			d.Text = DLG_TEXT[58];
			Link.l1 = DLG_TEXT[59];
			Link.l1.go = "exit2";
		break;
	}
}